// RangeImageViewerDoc.h : CRangeImageViewerDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RANGEIMAGEVIEWERDOC_H__D5C53FD7_28A5_4F0E_A52B_26F56A53A1E0__INCLUDED_)
#define AFX_RANGEIMAGEVIEWERDOC_H__D5C53FD7_28A5_4F0E_A52B_26F56A53A1E0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RangeImage.h"
#include "FileManager.h"
#include "Smoother.h"

#include "NoiseDialog.h"
#include "RidgeDialog.h"
#include "SmoothDialog.h"
#include "NormalDialog.h"

class CRangeImageViewerDoc : public CDocument
{
protected: // VACY@\݂̂쐬܂B
	CRangeImageViewerDoc();
	DECLARE_DYNCREATE(CRangeImageViewerDoc)

// Agr[g
public:
	RangeImage* image;
	FileManager* file_manager;
	Smoother* smoother;
	SmoothDialog* smooth_dia;
	NoiseDialog* noise_dia;
	RidgeDialog* ridge_dia;
	NormalDialog* normal_dia;
	RangeImage* last_image;
	int mode;

// Iy[V
public:

//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CRangeImageViewerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Cve[V
public:
	void changeView();
	void drawImage();
	virtual ~CRangeImageViewerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CRangeImageViewerDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnImage();
	afx_msg void OnWire();
	afx_msg void OnVNormal();
	afx_msg void OnSmooth();
	afx_msg void OnRidge();
	afx_msg void OnNormal();
	afx_msg void OnNoise();
	afx_msg void OnFNormal();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileSave();
	afx_msg void OnUndo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_RANGEIMAGEVIEWERDOC_H__D5C53FD7_28A5_4F0E_A52B_26F56A53A1E0__INCLUDED_)
