// RangeImageViewerView.h : CRangeImageViewerView NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RANGEIMAGEVIEWERVIEW_H__D22AB589_0278_4394_BAB9_1E893CB59F64__INCLUDED_)
#define AFX_RANGEIMAGEVIEWERVIEW_H__D22AB589_0278_4394_BAB9_1E893CB59F64__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>

class CRangeImageViewerView : public CView
{
protected: // VACY@\݂̂쐬܂B
	CRangeImageViewerView();
	DECLARE_DYNCREATE(CRangeImageViewerView)

// Agr[g
public:
	CRangeImageViewerDoc* GetDocument();

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CRangeImageViewerView)
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷ۂɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Cve[V
public:
	void changeView();
	void drawImage(RangeImage* image);
	void wireFrame(RangeImage* image);
	void setViewMode(bool isPerspective, int mode);
	void drawImageWithRidge(RangeImage* image);
	void flatShading(RangeImage *image);
	void drawShadedImage(RangeImage* image);
	virtual ~CRangeImageViewerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	HGLRC m_hRC;
	GLdouble eye[3], center[3];
	GLfloat Rx,Ry,Rz;
	int px, py;
	float vx[3], vy[3];
	BOOL isLPressed, isRPressed;
	bool isPerspective;
	float view_angle;
	float shift_x, shift_y, shift_z;

protected:
	void initGL();

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CRangeImageViewerView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // RangeImageViewerView.cpp t@CfobO̎gp܂B
inline CRangeImageViewerDoc* CRangeImageViewerView::GetDocument()
   { return (CRangeImageViewerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_RANGEIMAGEVIEWERVIEW_H__D22AB589_0278_4394_BAB9_1E893CB59F64__INCLUDED_)
